/*
Copyright 2017-2023 Ian Jauslin

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

#include "statistics.h"

// run this at each step to compute the running average
double average_step(
  // the value at the step
  double val,
  // the average computed so far
  double avg,
  uint64_t t,
  uint64_t starting_time,
  uint64_t print_freq,
  uint64_t first_box
){

  // running average
  // reset averages
  if(t % print_freq == 1){
    return(0);
  }

  // compute average
  // different computationin first box if starting_time is not a multiple of print_freq
  if(t < starting_time + first_box){
    return(avg+val/first_box);
  } else {
    return(avg+val/print_freq);
  }
}
